from urllib.parse import urlencode, parse_qsl, unquote
from xbmcplugin import addDirectoryItem, endOfDirectory, setResolvedUrl, setContent, setPluginCategory
from xbmcaddon import Addon
from json import loads
from datetime import datetime
from calendar import timegm
from time import gmtime
import re, sys, urlquick, xbmcgui
addon_url = sys.argv[0]
HANDLE = int(sys.argv[1])
addon_name = Addon().getAddonInfo('name')
ICON = Addon().getAddonInfo('icon')
UA = 'Mozilla/5.0 (Linux; Android 14; Pixel 8 Pro Build/AP1A.261212) AppleWebKit/605.1.15 (KHTML, like Gecko) Chrome/129.0.0.0 Mobile Safari/605.1.15 EdgA/129.0.0.0'
timestamp = timegm(gmtime())
def get_url(**kwargs):
    return f'{addon_url}?{urlencode(kwargs)}'
def addDir(title, dir_url, is_folder):
    list_item = xbmcgui.ListItem(label=title)
    list_item.setArt({'icon': ICON, 'thumb': ICON, 'poster': ICON})
    info_tag = list_item.getVideoInfoTag()
    info_tag.setTitle(title)
    info_tag.setPlot(title)
    if is_folder is False:
        setContent(HANDLE, 'episodes')
        list_item.setProperty('IsPlayable', 'true')
    else:
        setContent(HANDLE, 'tvshows')
    addDirectoryItem(HANDLE, dir_url, list_item, is_folder)
def getlink(url, ref, luu):
    r = urlquick.get(url, timeout=20, max_age=luu, headers={'user-agent': UA,'referer': ref.encode('utf-8')})
    r.encoding = 'utf-8'
    return r
def router(paramstring):
    params = dict(parse_qsl(paramstring))
    if not params:
        addDir('EVENT', get_url(mode = 'live_socolive'), True)
        u = f'https://json.vnres.co/matches.json?v={timestamp}'
        resp = getlink(u, u, 400)
        nd = re.search(r'(\{.*\})', resp.text, re.DOTALL)[1]
        m = loads(nd)
        mh = m['data']['0']
        for k in mh:
            tg = datetime.fromtimestamp(int(k['matchTime'])/1000).strftime('%H:%M %d/%m')
            tenm = f"{tg} {k['hostName']} vs {k['guestName']}"
            addDir(tenm, get_url(mode = 'list_socolive', idv = k['scheduleId'], name=tenm), True)
        endOfDirectory(HANDLE)
    elif params['mode'] == 'list_socolive':
        setPluginCategory(HANDLE, params['name'])
        u = f"https://json.vnres.co/matches.json?v={timestamp}"
        resp = getlink(u, u, 400)
        nd = re.search(r'(\{.*\})', resp.text, re.DOTALL)[1]
        m = loads(nd)
        mh = m['data']['0']
        v = ((l['nickName'], l['anchor']['roomNum']) for k in mh for l in k['anchors'] if k['scheduleId'] == int(params['idv']))
        for k in v:
            tenm = f"{k[0]} - {params['name']}"
            addDir(tenm, get_url(mode = 'play', id = k[1]), False)
        endOfDirectory(HANDLE)
    elif params['mode'] == 'live_socolive':
        setPluginCategory(HANDLE, 'EVENT')
        u = f"http://json.vnres.co/all_live_rooms.json?v={timestamp}"
        resp = getlink(u, u, 400)
        nd = re.search(r'(\{.*\})', resp.text, re.DOTALL)[1]
        m = loads(nd)
        mh = m['data']['hot']
        for k in mh:
            tenm = f'{k["title"]} ({k["anchor"]["nickName"]})'
            addDir(tenm, get_url(mode = 'play', id = k['roomNum']), False)
        endOfDirectory(HANDLE)
    elif params['mode'] == 'play':
        url = f'https://json.vnres.co/room/{params["id"]}/detail.json?v={timestamp}'
        r = getlink(url, url,-1)
        nd = re.search(r'(\{.*\})', r.text, re.DOTALL)[1]
        play_item = xbmcgui.ListItem(offscreen=True)
        linkplay = loads(nd)['data']['stream']['hdFlv']
        linkplay = re.sub(r'\s+', '%20', linkplay.strip(), flags=re.UNICODE)
        play_item.setPath(linkplay)
        setResolvedUrl(HANDLE, True, listitem=play_item)
    else:
        raise ValueError(f'Tham số {paramstring} không hợp lệ!')
if __name__ == '__main__':
    try:
        router(sys.argv[2][1:])
    except:
        xbmcgui.Dialog().notification(addon_name, 'Không lấy được dữ liệu', ICON)